Ext.define('DSS.component.ConditionConfigurator', {
    extend : 'DSS.component.Base',
    mixins : {
        observable : 'Ext.util.Observable'
    },
    height : '100%',
    layout : 'border',
    selectedElement : null,
    gridStore : null,
    grids : {},
    macPanel : null,
    mainGrid : null,
    lblSelectorAnzeige : null,
    oButtonNew : null,
    oButtonEdit : null,
    oButtonUp : null,
    oButtonDown : null,
    oButtonDelete : null,
    iDefaultWidth : 150,
    iDefaultHeight : 293,
    oButtonDelete : null,
    updatePanelDescription: function() {        
        if (this.oActualValue==null) {
            this.macPanel.setTitle(_('edit condition: ') + _('incomplete condition'));
        } else {
            switch (this.oActualValue.type) {
            }
            this.macPanel.setTitle(_('edit condition: ') + _('incomplete condition'));            
        }
    },
    defMainGridRenderer : function(val, metadata, record, colIdx, store, view) {
        var oAction = record.get('condition');
        return "condi";
    },
    fFeatureEnabled: {
        enabler:false,
        weekdays:false,
        timeframe:false,
        systemstate:false,
        zonestate:false
    },
    setHeight : function(oHeight) {
        this.macPanel.setHeight(oHeight - 30);
        this.iDefaultHeight = oHeight - 57;
        for ( var oKey in this.grids)
            this.grids[oKey].setHeight(this.iDefaultHeight);
        this.callParent(arguments);
    },
    defMacGridRenderer : function(val, metadata, record, colIdx, store, view) {
        if (record.get('name') == '-') {
            return '<hr>';
        } 
        var fHasIcon=false;
        if (record.get('icon') != null)
        {
            fHasIcon=true;
        }
        var fHasNext=false;
        if (record.get('next') == true)  // definition erfordert weiterbutton
        {
            fHasNext=true;
        }
        if (record.get('group') != null)   // ist eine gruppe -> weiterbutton
        {
            fHasNext=true;
        }
        if (record.get('dSID') != null)    // ist ein device -> weiterbutton
        {
            fHasNext=true;
        }
        var fIsCheckable=false;
        if (record.get('checkable') != null) 
            if (record.get('checkable')) {
                fHasNext=false; // checkboxen niemals weiterbuttons
                fHasIcon=false; // keine Icons nach Checkboxen
                fIsCheckable=true;
            }

        var fIsPassive=false;        
        if (record.get('passive')!=null)
            if (record.get('passive'))
                fIsPassive=true;
        if (fIsPassive) {
            fHasNext=false;               // spalte disabled -> niemals weiterbutton
            fIsChecked=false;             // spalte disabled -> kann nicht gechecked sein
        }

        var sReturn='<table style="height:16px;"><tr>';
        var iColspaceCounter=3;
        if (fHasIcon)
        {
            iColspaceCounter--;  
            sReturn+='<td><img src="' + record.get('icon') + '" style="margin-right: 5px;"></td>';
        }
        if (fIsCheckable)
        {
            iColspaceCounter--;  
            if (record.get('checked') == true)
            {
                sReturn+='<td style="padding-right: 5px;"><div style="width:13px;height:13px;background-image:url(' + dss.staticDataModel.baseImagePath + 'dss/checkbox.gif); background-position: 0px -13px;" /></td>';
            } else {
                sReturn+='<td style="padding-right: 5px;"><div style="width:13px;height:13px;background-image:url(' + dss.staticDataModel.baseImagePath + 'dss/checkbox.gif);" /></td>';
            }
        }
        if (fHasNext)
            iColspaceCounter--;
        if (fIsPassive) {
            sReturn+='<td style="color:#888888;" colspan="'+iColspaceCounter+'" width="100%">' + record.get('name') + '</td>';
        } else {
            sReturn+='<td colspan="'+iColspaceCounter+'" width="100%">' + record.get('name') + '</td>';
        }
        if (fHasNext) {
            sReturn+='<td>&gt;</td>';
        }
        return sReturn +'</tr></table>';  

    },
    initStores : function() {
        var me = this;
        this.gridStore = Ext.create('Ext.data.Store', {

            fields : [ 'pos', 'condition'],
            proxy : {
                type : 'memory',
                reader : {
                    type : 'json',
                    root : 'items'
                }
            },
            listeners : {
                datachanged : function(store, eOpts) {
                    if (store.getCount()==0)
                        me.lblSelectorAnzeige.setText( _('no condition'),false);
                    else if (store.getCount()==1)
                        me.lblSelectorAnzeige.setText(_('1 condition'),false);
                    else
                        me.lblSelectorAnzeige.setText('' + store.getCount() + _(' conditions'),false);
                }
            }
        });

        if (Ext.data.StoreManager.lookup('conditionConfigurator_l1Store') == null) {
            Ext.create('Ext.data.Store', {
                storeId : 'conditionConfigurator_l1Store',
                fields : [ 'id', 'name', 'next', 'icon' ],
                proxy : {
                    type : 'memory',
                    reader : {
                        type : 'json',
                        root : 'items'
                    }
                }
            });            
        }      
        Ext.data.StoreManager.lookup('conditionConfigurator_l1Store').removeAll();
        var Aktionen = [];
        if (this.fFeatureEnabled.enabler) {
            Aktionen.push({
                name : 'Enabled',
                id : 0,
                next : true,
                icon : null
            });
        }

        if (this.fFeatureEnabled.weekdays) {
            Aktionen.push({
                name : 'Weekdays',
                id : 1,
                next : true,
                icon : null
            });
        }
        if (this.fFeatureEnabled.timeframe) {
            Aktionen.push({
                name : 'Timeframe',
                id : 2,
                next : true,
                icon : null
            });
        }
        if (this.fFeatureEnabled.systemstate) {
            Aktionen.push({
                name : 'SystemState',
                id : 3,
                next : true,
                icon : null
            });
        }
        if (this.fFeatureEnabled.zonestate) {
            Aktionen.push({
                name : 'ZoneState',
                id : 4,
                next : true,
                icon : null
            });
        }
        

        Ext.data.StoreManager.lookup('conditionConfigurator_l1Store').add(Aktionen);
        if (Ext.data.StoreManager.lookup('conditionConfigurator_zoneStore') == null) {
            Ext.create('Ext.data.Store', {
                storeId : 'conditionConfigurator_zoneStore',
                fields : [ 'ZoneID', 'name' ],
                proxy : {
                    type : 'memory',
                    reader : {
                        type : 'json',
                        root : 'items'
                    }
                }
            });
            Ext.data.StoreManager.lookup('conditionConfigurator_zoneStore').add(dss.staticDataModel.getZoneArray());
        }
    },    
    constructEnabler:function(){
        this.grids.lvlEnableCheckbox=Ext.create('Ext.form.RadioGroup',{
            fieldLabel:_('Enabled (choose one to set the condition?'),
            items:[{   inputValue:false,
                       boxLabel:_('disabled - that condition is allways disabled'),
                       name:'autoMode'},
                   {   inputValue:true,
                       boxLabel:_('enabled - that condition is enabled'),
                       name:'autoMode'}
                   ],
            height : 60,
            width : 610,
            margin : "10 0 0 10",
            columns:1,
            labelAlign:'top',
            style: {color:"#005138"}
        });

        
        this.grids.lvlEnable = Ext.create('Ext.panel.Panel', {
            height : this.iDefaultHeight,
            width : 624,
            autoScroll : true,
            items : [ this.grids.lvlEnableCheckbox ]
        });

        this.grids.lvlEnable.parent = this;
        this.grids.lvlEnableCheckbox.parent = this;
        this.macPanel.add(this.grids.lvlEnable);
    },
    constructWeekdays:function(){

        this.grids.lvlWeekday = Ext.create('Ext.panel.Panel', {
            height : this.iDefaultHeight,
            width : 624,
            autoScroll : true,
            items : [ this.grids.lvlEnableCheckbox ]
        });

        this.grids.lvlWeekday.parent = this;
        this.grids.lvlEnableCheckbox.parent = this;
        this.macPanel.add(this.grids.lvlWeekday);        
    },
    constructTimeframe:function(){
        
    },
    constructSystemState:function(){
        
    },
    constructZoneState:function(){
        
    },
    constructMacGrids : function() {

        var lvl1TempStore = Ext.create('Ext.data.Store', {
            fields : [ 'id', 'name', 'next', 'icon' ],
            proxy : {
                type : 'memory',
                reader : {
                    type : 'json',
                    root : 'items'
                }
            }
        });

        var lvl1Store = Ext.data.StoreManager.lookup('conditionConfigurator_l1Store');
        lvl1Store.each(function(record) {
            var oNewRecord = record.copy();
            lvl1TempStore.add(oNewRecord);
        });

        this.grids.lvl1 = Ext.create('Ext.grid.Panel', {
            height : this.iDefaultHeight,
            width : this.iDefaultWidth,
            hideHeaders:true,
            autoScroll : true,
            viewConfig : {
                stripeRows : true
            },
            store : lvl1Store,
            columns : [ {
                sortable : false,
                hideable : false,
                dataIndex : 'name',
                flex : 1,
                renderer : this.defMacGridRenderer
            } ]
        });
        this.grids.lvl1.getSelectionModel().store = this.grids.lvl1.store;
        this.grids.lvl1.parent = this;

        this.grids.lvl1.on('itemclick', function(grid, record) {
            this.parent.macPanel.remove(this.parent.grids.lvlEnable);
            this.parent.oActualValue =null;
            var fIsPassive=false;
            if (record.get('passive')!=null) {
                if (record.get('passive')==true) {
                    this.getSelectionModel().deselect(record);
                    fIsPassive=true;
                }
            }
            
            if (!fIsPassive) {
                if (record.get('id') == 0) {
                    this.parent.constructEnabler();
                }
                if (record.get('id') == 1) {
                    this.parent.constructWeekdays();
                }
                if (record.get('id') == 2) {
                    this.parent.constructTimeframe();
                }
                if (record.get('id') == 3) {
                    this.parent.constructSystemState();
                }
                if (record.get('id') == 4) {
                    this.parent.constructZoneState();
                }
            }
            this.parent.macPanel.doLayout();
        });

    },
    setSelectedSubItem : function(oObject) {
        this.oActualValue=oObject;
        if (this.getSelectedMainRecord() == null) {
            var oNewRecord=this.gridStore.add({
                pos : 0,
                condition : oObject
            });
            this.setSelectedMainRecord(this.gridStore.getCount()-1);
        } else {
            this.getSelectedMainRecord().set('condition', oObject);
            this.getSelectedMainRecord().commit();
        }
        this.removeCls('myInvalid');
        this.updatePanelDescription();
    },
    setSelectedMainRecord: function(index) {
        this.mainGrid.getSelectionModel().select(index);
        this.setMacGrid((this.getSelectedMainRecord()).get('condition'));
    },
    getSelectedMainRecord: function() {
        if (this.mainGrid.getSelectionModel().getSelection()==null)
            return null;
        return this.mainGrid.getSelectionModel().getSelection()[0];
    },
    deselectMainGrid:function() {
        var oldSelect=this.getSelectedMainRecord();
        if (oldSelect!=null) {
            this.mainGrid.getSelectionModel().deselect(oldSelect);
        }
    },
    setMacGrid : function(oObject) {        
        this.macPanel.remove(this.grids.lvlEnable);
        this.macPanel.doLayout();
    },
    eventHandlerSelectionChange : function (view, selections, options) {
        var mThis=this;
        if (this.parent!=null)
            mThis=this.parent;
        if (selections.length > 0) {
            mThis.oButtonEdit.setDisabled(false);
            mThis.oButtonDelete.setDisabled(false);
            var selIndex = -1;
            for ( var iIndex = 0; iIndex < view.store.getCount(); iIndex++) {
                if (view.store.getAt(iIndex) == selections[0])
                    selIndex = iIndex;
            }
            mThis.oButtonUp.setDisabled(selIndex == 0);
            mThis.oButtonDown.setDisabled(selIndex == (view.store.getCount() - 1));
            var iIndex = mThis.mainGrid.store.indexOf(selections[0]);
            mThis.lblSelectorAnzeige.setText(Ext.String.format2(_('condition {index}/{count}'),{index:''+(iIndex + 1),count:''+view.store.getCount()}),false);
        } else {
            mThis.oButtonEdit.setDisabled(true);
            mThis.oButtonDelete.setDisabled(true);
            mThis.oButtonUp.setDisabled(true);
            mThis.oButtonDown.setDisabled(true);
            if (view.store.getCount()==0)
                mThis.lblSelectorAnzeige.setText(_('no condition'),false);
            else if (view.store.getCount()==1)
                mThis.lblSelectorAnzeige.setText(_('1 condition'),false);
            else
                mThis.lblSelectorAnzeige.setText('' + view.store.getCount() + _(' condition'),false);
        }
    },
    constructor : function(config) {
        Ext.tip.QuickTipManager.init();
        
        var mThis=this;

        this.fFeatureEnabled= {
            enabler:false,
            weekdays:false,
            timeframe:false,
            systemstate:false,
            zonestate:false
        };
        if (config.fFeatureEnabled.enabler!=null)
            if (config.fFeatureEnabled.enabler)
                this.fFeatureEnabled.enabler=config.fFeatureEnabled.enabler;
        if (config.fFeatureEnabled.weekdays!=null)
            if (config.fFeatureEnabled.weekdays)
                this.fFeatureEnabled.weekdays=config.fFeatureEnabled.weekdays;
        if (config.fFeatureEnabled.timeframe!=null)
            if (config.fFeatureEnabled.timeframe)
                this.fFeatureEnabled.timeframe=config.fFeatureEnabled.timeframe;
        if (config.fFeatureEnabled.systemstate!=null)
            if (config.fFeatureEnabled.systemstate)
                this.fFeatureEnabled.systemstate=config.fFeatureEnabled.systemstate;
        if (config.fFeatureEnabled.zonestate!=null)
            if (config.fFeatureEnabled.zonestate)
                this.fFeatureEnabled.zonestate=config.fFeatureEnabled.zonestate;
        
        this.initStores();
        this.constructMacGrids();

        this.lblSelectorAnzeige = Ext.create('Ext.form.Label', {
            width : 200,
            height : 22,
            padding : 4,
            style : {
                textAlign : 'right',
            }
        });

        this.oButtonNew = Ext.create('Ext.button.Button', {
            iconCls : 'icon-add-action',
            text : _('new condition'),
            handler : function() {
                this.parent.oActualValue=null;
                this.parent.macPanel.expand(true);
                
                this.parent.setMacGrid();
                this.parent.deselectMainGrid();
            }
        });
        this.oButtonNew.parent = this;

        this.oButtonEdit = Ext.create('Ext.button.Button', {
            iconCls : 'icon-edit-action',
            text : _('edit condition'),
            disabled : true,
            handler : function() {
                if (this.parent.macPanel.collapsed) {
                    this.parent.macPanel.expand(true);
                    this.parent.oActualValue=this.parent.getSelectedMainRecord().get('action');
                    this.parent.setMacGrid(this.parent.oActualValue);
                } else {
                    this.parent.macPanel.collapse(Ext.Component.DIRECTION_BOTTOM, true);                    
                }
            }
        });
        this.oButtonEdit.parent = this;

        this.oButtonUp = Ext.create('Ext.button.Button', {
            iconCls : 'icon-left-action',
            disabled : true,
            handler : function() {
                var iIndex = this.parent.mainGrid.store.indexOf(this.parent.getSelectedMainRecord());
                mThis.setSelectedMainRecord(iIndex - 1);
            }
        });
        this.oButtonUp.parent = this;

        this.oButtonDown = Ext.create('Ext.button.Button', {
            iconCls : 'icon-right-action',
            disabled : true,
            handler : function() {
                var iIndex = this.parent.mainGrid.store.indexOf(this.parent.getSelectedMainRecord());
                mThis.setSelectedMainRecord(iIndex + 1);
            }
        });
        this.oButtonDown.parent = this;

        this.oButtonDelete = Ext.create('Ext.button.Button', {
            iconCls : 'icon-delete-action',
            tooltip:  _('delete condition'),
            disabled : true,
            handler : function() {
                this.parent.macPanel.collapse(Ext.Component.DIRECTION_BOTTOM, true);
                this.parent.gridStore.remove(this.parent.getSelectedMainRecord());
            }
        });
        this.oButtonDelete.parent = this;

        this.mainGrid = Ext.create('Ext.grid.Panel', {
            enableColumnHide : false,
            enableColumnMove : false,
            selType : 'rowmodel',
            border : '0',
            region : 'center',
            height : "100%",
            store : this.gridStore,
            hideHeaders : true,
            autoScroll: false,
            columns : [ {
                header : _('condition'),
                dataIndex : 'condition',
                sortable : false,
                hideable : false,
                flex:1,
                renderer : this.defMainGridRenderer
            } ],
            tbar : [ this.oButtonNew, this.oButtonEdit,
            // { xtype: 'button', text: 'Erweiterte Ansicht',
            // id: 'action-selector-btn-extended' ,
            // disabled:true},
            '->', this.lblSelectorAnzeige, this.oButtonUp, this.oButtonDown, this.oButtonDelete ]
        });
        this.mainGrid.parent = this;
        this.mainGrid.on({
            selectionchange : this.eventHandlerSelectionChange,
            itemdblclick : function(grid, record,item,index,e) {
                this.parent.macPanel.expand(true);
                this.parent.setMacGrid((this.parent.getSelectedMainRecord()).get('condition'));
            }
        });

        
        
        this.macPanel = Ext.create('Ext.panel.Panel', {
            border : '0',
            region : 'south',
            title : _('show condition editor'),
            collapsible : true,
            collapsed : false,
            collapseMode : 'header',
            autoScroll : true,
            height : 320,
            layout : {
                type : 'hbox'
            },
            items : [ this.grids.lvl1 ],
            listeners : {
                collapse : function(pPanel) {
                    pPanel.up().macPanel.setTitle('');
                    pPanel.up().oButtonEdit.setDisabled(pPanel.up().getSelectedMainRecord()==null);
                    pPanel.up().oButtonEdit.setText(_('edit condition'));
                    pPanel.up().mainGrid.doLayout();
                 },
                expand : function(pPanel) {
                    pPanel.up().updatePanelDescription();
                    pPanel.up().oButtonEdit.setDisabled(false);
                    pPanel.up().oButtonEdit.setText(_('show all conditions'));
                    pPanel.up().mainGrid.doLayout();
                }
            },
            scroll : 'horizontal'

        });

        Ext.apply(this, {
            items : [ this.mainGrid, this.macPanel ]
        });

        this.callParent(arguments);
    },
    reset : function() {
        this.setValue(null);
    },
    setValue : function(values) {
        var me = this;
        this.removeCls('myInvalid');
        if (values == null) {
            this.gridStore.removeAll();
            this.doLayout();
            this.macPanel.expand(false);
            this.lblSelectorAnzeige.setText(_('no condition'),false);
            this.setMacGrid();
        } else {
            this.gridStore.removeAll();
            for ( var iIndex = 0; iIndex < values.length; iIndex++) {
            }
            this.setSelectedMainRecord(0);
            if (values.length==1) {
                this.macPanel.expand(false);
                this.oActualValue=(this.getSelectedMainRecord()).get('condition');
                this.setMacGrid(this.oActualValue);
            }
            else
                this.macPanel.collapse(Ext.Component.DIRECTION_BOTTOM, false);
        }

    },
    isValid : function() {
        return true;
    },
    getValue : function() {
        var oResult = [];
        this.gridStore.each(function(record) {
        });
        return oResult        
    }
});

